package com.poststats.rs.api.model;

import io.swagger.v3.oas.annotations.Parameter;
import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Positive;
import jakarta.ws.rs.DefaultValue;
import jakarta.ws.rs.QueryParam;

public class Pagination {

	@Parameter(description = "A page number, starting at the default of 1")
	@QueryParam("page")
	@DefaultValue("1")
	@Positive
	private short page;

	@Parameter(description = "A number of results per page, starting at 1; the default is 20")
	@QueryParam("perPage")
	@DefaultValue("20")
	@Positive
	@Max(value = 100)
	private short perPage;

	public short getPage() {
		return page;
	}

	public void setPage(short page) {
		this.page = page;
	}

	public short getPerPage() {
		return perPage;
	}

	public void setPerPage(short perPage) {
		this.perPage = perPage;
	}

	public Pagination withPage(short page) {
		this.page = page;
		return this;
	}

	public Pagination withPerPage(short perPage) {
		this.perPage = perPage;
		return this;
	}

}
